{ config
, lib
, pkgs
, ...
}: {
  programs.alvr = {
    enable = true;
    openFirewall = true;
  };

  xdg.portal = {
    enable = true;
    xdgOpenUsePortal = true;
  };

  programs.steam = {
    enable = true;
    protontricks.enable = true;

    remotePlay.openFirewall = true;
    dedicatedServer.openFirewall = true;

    extraPackages = with pkgs; [
      mangohud
    ];
    extraCompatPackages = with pkgs; [
      proton-ge-custom
    ];

    package = pkgs.steam.override {
      extraPkgs = pkgs:
        with pkgs; [
          xorg.libXcursor
          xorg.libXi
          xorg.libXinerama
          xorg.libXScrnSaver
          libpng
          libpulseaudio
          libvorbis
          stdenv.cc.cc.lib
          libkrb5
          keyutils
        ];
    };
  };
  programs.xwayland.enable = true;
  programs.gamescope.enable = true;
  programs.immersed.enable = true;

  environment.systemPackages = with pkgs; [
    protonup-qt
    xorg.xorgserver
    wlx-overlay-s
  ];

  # hardware.xone.enable = true; # USB only, not needed ATM, and incompatible with recent kernels, bluetooth FTW
  # hardware.xpadneo.enable = true; # Wireless # Needed to up to nixos-small to fix
  hardware.bluetooth.enable = true;
  hardware.steam-hardware.enable = true;
}
